// this file is generated! do not modify
#include "aubio-types.h"

// pitchshift structure
typedef struct{
    PyObject_HEAD
    // pointer to aubio object
    aubio_pitchshift_t *o;
    // input parameters
    char_t *  method; smpl_t transpose; uint_t hop_size; uint_t samplerate;
    // do input vectors
    fvec_t  in;
    // output results
    PyObject *out; fvec_t c_out;
} Py_pitchshift;

#ifndef PYAUBIO_pitchshift_doc
#define PYAUBIO_pitchshift_doc "pitchshift(method=\"default\", transpose=0., hop_size=Py_default_vector_length / 2, samplerate=Py_aubio_default_samplerate)"
#endif /* PYAUBIO_pitchshift_doc */

static char Py_pitchshift_doc[] = ""
PYAUBIO_pitchshift_doc
"";

// new pitchshift
static PyObject *
Py_pitchshift_new (PyTypeObject * pytype, PyObject * args, PyObject * kwds)
{
    Py_pitchshift *self;

    char_t* method = NULL;
    smpl_t transpose = 0.0;
    uint_t hop_size = 0;
    uint_t samplerate = 0;
    static char *kwlist[] = { "method", "transpose", "hop_size", "samplerate", NULL };
    if (!PyArg_ParseTupleAndKeywords (args, kwds, "|sfII", kwlist,
              &method, &transpose, &hop_size, &samplerate)) {
        return NULL;
    }

    self = (Py_pitchshift *) pytype->tp_alloc (pytype, 0);
    if (self == NULL) {
        return NULL;
    }

    self->method = "default";
    if (method != NULL) {
        self->method = method;
    }

    self->transpose = 0.;
    if (transpose != 0.) {
        self->transpose = transpose;
    }

    self->hop_size = Py_default_vector_length / 2;
    if ((sint_t)hop_size > 0) {
        self->hop_size = hop_size;
    } else if ((sint_t)hop_size < 0) {
        PyErr_SetString (PyExc_ValueError, "can not use negative value for hop_size");
        return NULL;
    }

    self->samplerate = Py_aubio_default_samplerate;
    if ((sint_t)samplerate > 0) {
        self->samplerate = samplerate;
    } else if ((sint_t)samplerate < 0) {
        PyErr_SetString (PyExc_ValueError, "can not use negative value for samplerate");
        return NULL;
    }

    return (PyObject *)self;
}

// init pitchshift
static int
Py_pitchshift_init (Py_pitchshift * self, PyObject * args, PyObject * kwds)
{

  self->o = new_aubio_pitchshift(self->method, self->transpose, self->hop_size, self->samplerate);

  // return -1 and set error string on failure
  if (self->o == NULL) {
    PyErr_Format (PyExc_RuntimeError, "failed creating pitchshift");
    return -1;
  }

  // TODO get internal params after actual object creation?

  // create outputs
  self->out = new_py_fvec(self->hop_size);

  return 0;
}

// del pitchshift
static void
Py_pitchshift_del  (Py_pitchshift * self, PyObject * unused)
{
  if (self->out) {
    Py_DECREF(self->out);
  }
  if (self->o) {
    del_aubio_pitchshift(self->o);
  }
  Py_TYPE(self)->tp_free((PyObject *) self);
}

// do pitchshift
static PyObject*
Pyaubio_pitchshift_do  (Py_pitchshift * self, PyObject * args)
{
    PyObject *outputs;
    PyObject *py_in;
    if (!PyArg_ParseTuple (args, "O", &py_in)) {
        return NULL;
    }

    if (!PyAubio_ArrayToCFvec(py_in, &(self->in))) {
        return NULL;
    }

    if (self->in.length != self->hop_size) {
        PyErr_Format (PyExc_ValueError,
            "input size of pitchshift should be %d, not %d",
            self->hop_size, self->in.length);
        return NULL;
    }

    Py_INCREF(self->out);
    if (!PyAubio_ArrayToCFvec(self->out, &(self->c_out))) {
        return NULL;
    }

    aubio_pitchshift_do(self->o, &(self->in), &(self->c_out));

    outputs = self->out;

    return outputs;
}

static PyMemberDef Py_pitchshift_members[] = {
  {"method", T_STRING, offsetof (Py_pitchshift, method), READONLY, "TODO documentation"},
  {"transpose", AUBIO_NPY_SMPL, offsetof (Py_pitchshift, transpose), READONLY, "TODO documentation"},
  {"hop_size", T_INT, offsetof (Py_pitchshift, hop_size), READONLY, "TODO documentation"},
  {"samplerate", T_INT, offsetof (Py_pitchshift, samplerate), READONLY, "TODO documentation"},
  {NULL}, // sentinel
};

// pitchshift setters

static PyObject *
Pyaubio_pitchshift_set_pitchscale (Py_pitchshift *self, PyObject *args)
{
  uint_t err = 0;
  
   smpl_t pitchscale;


  if (!PyArg_ParseTuple (args, "f", &pitchscale)) {
    return NULL;
  }

  err = aubio_pitchshift_set_pitchscale (self->o ,pitchscale);

  if (err > 0) {
    if (PyErr_Occurred() == NULL) {
      PyErr_SetString (PyExc_ValueError, "error running aubio_pitchshift_set_pitchscale");
    } else {
      // change the RuntimeError into ValueError
      PyObject *type, *value, *traceback;
      PyErr_Fetch(&type, &value, &traceback);
      Py_XDECREF(type);
      type = PyExc_ValueError;
      Py_XINCREF(type);
      PyErr_Restore(type, value, traceback);
    }
    return NULL;
  }
  Py_RETURN_NONE;
}

static PyObject *
Pyaubio_pitchshift_set_transpose (Py_pitchshift *self, PyObject *args)
{
  uint_t err = 0;
  
   smpl_t transpose;


  if (!PyArg_ParseTuple (args, "f", &transpose)) {
    return NULL;
  }

  err = aubio_pitchshift_set_transpose (self->o ,transpose);

  if (err > 0) {
    if (PyErr_Occurred() == NULL) {
      PyErr_SetString (PyExc_ValueError, "error running aubio_pitchshift_set_transpose");
    } else {
      // change the RuntimeError into ValueError
      PyObject *type, *value, *traceback;
      PyErr_Fetch(&type, &value, &traceback);
      Py_XDECREF(type);
      type = PyExc_ValueError;
      Py_XINCREF(type);
      PyErr_Restore(type, value, traceback);
    }
    return NULL;
  }
  Py_RETURN_NONE;
}

// pitchshift getters

static PyObject *
Pyaubio_pitchshift_get_latency (Py_pitchshift *self, PyObject *unused)
{
  uint_t latency = aubio_pitchshift_get_latency (self->o);
  return (PyObject *)PyLong_FromLong (latency);
}

static PyObject *
Pyaubio_pitchshift_get_pitchscale (Py_pitchshift *self, PyObject *unused)
{
  smpl_t pitchscale = aubio_pitchshift_get_pitchscale (self->o);
  return (PyObject *)PyFloat_FromDouble (pitchscale);
}

static PyObject *
Pyaubio_pitchshift_get_transpose (Py_pitchshift *self, PyObject *unused)
{
  smpl_t transpose = aubio_pitchshift_get_transpose (self->o);
  return (PyObject *)PyFloat_FromDouble (transpose);
}

static PyMethodDef Py_pitchshift_methods[] = {
  {"set_pitchscale", (PyCFunction) Pyaubio_pitchshift_set_pitchscale,
    METH_VARARGS, ""},
  {"set_transpose", (PyCFunction) Pyaubio_pitchshift_set_transpose,
    METH_VARARGS, ""},
  {"get_latency", (PyCFunction) Pyaubio_pitchshift_get_latency,
    METH_NOARGS, ""},
  {"get_pitchscale", (PyCFunction) Pyaubio_pitchshift_get_pitchscale,
    METH_NOARGS, ""},
  {"get_transpose", (PyCFunction) Pyaubio_pitchshift_get_transpose,
    METH_NOARGS, ""},
  {NULL} /* sentinel */
};

PyTypeObject Py_pitchshiftType = {
  //PyObject_HEAD_INIT (NULL)
  //0,
  PyVarObject_HEAD_INIT (NULL, 0)
  "aubio.pitchshift",
  sizeof (Py_pitchshift),
  0,
  (destructor) Py_pitchshift_del,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  (ternaryfunc)Pyaubio_pitchshift_do,
  0,
  0,
  0,
  0,
  Py_TPFLAGS_DEFAULT,
  Py_pitchshift_doc,
  0,
  0,
  0,
  0,
  0,
  0,
  Py_pitchshift_methods,
  Py_pitchshift_members,
  0,
  0,
  0,
  0,
  0,
  0,
  (initproc) Py_pitchshift_init,
  0,
  Py_pitchshift_new,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
};
